package com.huangge1199.ai.service;

import com.huangge1199.ai.config.SafeInputGuardrail;
import dev.langchain4j.service.Result;
import dev.langchain4j.service.SystemMessage;
import dev.langchain4j.service.guardrail.InputGuardrails;

import java.util.List;

/**
 * LangChainService
 *
 * @author huangge1199
 * @since 2025/7/12 10:25:27
 */
@InputGuardrails({SafeInputGuardrail.class})
public interface LangChainService {

    @SystemMessage(fromResource = "system-prompt.txt")
    String chat(String message);

    @SystemMessage(fromResource = "system-prompt.txt")
    Report chatForReport(String message);

    record Report(String name, List<String> list) {
    }

    @SystemMessage(fromResource = "system-prompt.txt")
    Result<String> chatWithRag(String message);
}
